ARG BASE_IMAGE

# Build dumb-init
FROM alpine AS dumb-init-builder

ARG DI_VER=1.2.5

WORKDIR /app

# Build dumb-init & download tshock
RUN apk add --update --no-cache build-base unzip curl && \
    curl -Lo - "https://github.com/Yelp/dumb-init/archive/refs/tags/v${DI_VER}.tar.gz" | tar -xzf - && \
    cd "dumb-init-${DI_VER}" && \
    make SHELL=/bin/sh && \
    mv dumb-init ..


# We use ${:-} instead of a default value because the argument is always passed
# to the build, it'll just be blank most likely
FROM ${BASE_IMAGE:-'eclipse-temurin:21-jre-alpine'}

# Build arguments
ARG MC_VERSION
ARG PAPERMC_VERSION

COPY ./alex /bin/alex

# Install alex binary
# ADD "https://git.rustybever.be/api/packages/Chewing_Bever/generic/alex/0.4.0/alex-linux-amd64" /bin/alex

# RUN chmod +x /bin/alex && \
#     addgroup -Sg 1000 paper && \
#     adduser -SHG paper -u 1000 paper

# Create worlds and config directory
WORKDIR /app
RUN mkdir -p worlds config/cache backups

# Download server file
# ADD "https://papermc.io/api/v2/projects/paper/versions/$MC_VERSION/builds/$PAPERMC_VERSION/downloads/paper-$MC_VERSION-$PAPERMC_VERSION.jar" server.jar
ADD "https://fill-data.papermc.io/v1/objects/0b32aa197452047a51772af05bb9fddc264304ad780dca87425a726d68f89149/paper-1.21.10-127.jar" server.jar

# Make sure the server user can access all necessary folders
# RUN chown -R paper:paper /app

# Store the cache in an anonymous volume, which means it won't get stored in the other volumes
# VOLUME /app/config/cache

ENV ALEX_JAR=/app/server.jar \
    ALEX_CONFIG=/app/config \
    ALEX_WORLD=/app/worlds \
    ALEX_BACKUP=/app/backups \
    ALEX_SERVER=paper \
    ALEX_SERVER_VERSION="${MC_VERSION}-${PAPERMC_VERSION}"

# Document exposed ports
EXPOSE 25565

# Switch to non-root user
# USER paper:paper

COPY --from=dumb-init-builder /app/dumb-init /dumb-init

ENTRYPOINT ["/dumb-init", "--"]
CMD /bin/alex run

# HEALTHCHECK --interval=30s --timeout=5s --start-period=1m --retries=5 \
#     CMD mcstatus localhost:25565 ping
